//+------------------------------------------------------------------+
//|                                                     rsi bars.mq4 |
//|                                  Copyright  2006, Forex-TSD.com |
//|                         Written by IgorAD,igorad2003@yahoo.co.uk |   
//|            http://finance.groups.yahoo.com/group/TrendLaboratory |                                      
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, Forex-TSD.com "
#property link      "http://www.forex-tsd.com/"

#property indicator_separate_window
#property indicator_minimum 0
#property indicator_maximum 1
#property indicator_buffers 5
#property indicator_color1 Navy
#property indicator_color2 Maroon

#property indicator_color3 Blue
#property indicator_color4 Red

#property indicator_color5 Yellow

#property indicator_width1 3
#property indicator_width2 3
#property indicator_width3 3
#property indicator_width4 3
#property indicator_width5 3

//---- input parameters
extern double periods=14;
extern double timeperiods=0;
extern double gamma=0.764;
extern int CountBars=1300;

extern int TF=0;


//---- indicator buffers
double UpBuffer[];
double DnBuffer[];
double MUpBuffer[];
double MDnBuffer[];
double MMnBuffer[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
  int init()
  {
   string short_name;
//---- indicator line
   SetIndexStyle(0,DRAW_HISTOGRAM,STYLE_SOLID,4);
   SetIndexStyle(1,DRAW_HISTOGRAM,STYLE_SOLID,4);
   SetIndexStyle(2,DRAW_HISTOGRAM,STYLE_SOLID,4);
   SetIndexStyle(3,DRAW_HISTOGRAM,STYLE_SOLID,4);
   SetIndexStyle(4,DRAW_HISTOGRAM,STYLE_SOLID,4);
   
   SetIndexBuffer(0,UpBuffer);
   SetIndexBuffer(1,DnBuffer);
   SetIndexBuffer(2,MUpBuffer);
   SetIndexBuffer(3,MDnBuffer);
   SetIndexBuffer(4,MMnBuffer);
   
   IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS));
//---- name for DataWindow and indicator subwindow label
   short_name="RSI Laguerre Bars("+periods+")";
   IndicatorShortName(short_name);
   SetIndexLabel(0,"UpTrend");
   SetIndexLabel(1,"DownTrend");
//----
   SetIndexDrawBegin(0,periods);
   SetIndexDrawBegin(1,periods);
//----
   return(0);
  }

//+------------------------------------------------------------------+
//| RSIFilter_v1                                                         |
//+------------------------------------------------------------------+
int start()
  {
   int    counted_bars=IndicatorCounted(), limit, shift;
  
   
   if(counted_bars<0) return(-1);
   limit=Bars-counted_bars;
    
   
 for(shift=limit;shift>=0;shift--)
  {   	

      double RSI1=iCustom(Symbol(),TF,"Laguerre MinusDi",periods,timeperiods,gamma,CountBars,0,shift);
      double RSI2=iCustom(Symbol(),TF,"Laguerre PlusDi",periods,timeperiods,gamma,CountBars,0,shift);
      
   	
      if ((RSI2 > RSI1) && (RSI2 > 0.5) && (RSI1 < 0.5)) {
       MUpBuffer[shift]=1.0;
	    MDnBuffer[shift]=0; 
	    UpBuffer[shift]=0;
	    DnBuffer[shift]=0;
	    MMnBuffer[shift]=0;
      }
      else if (RSI2 > RSI1) {
	    UpBuffer[shift]=1.0;
	    DnBuffer[shift]=0; 
	    MUpBuffer[shift]=0;
	    MDnBuffer[shift]=0; 
	    MMnBuffer[shift]=0;
	    }
	   else  if ((RSI2 < RSI1) && (RSI2 < 0.5) && (RSI1 > 0.5)) {
	    MDnBuffer[shift]=1.0; 
	    MUpBuffer[shift]=0;
	    UpBuffer[shift]=0;
	    DnBuffer[shift]=0;
	    MMnBuffer[shift]=0;
      }
	   else if (RSI2 < RSI1) 
	    {
	     DnBuffer[shift]=1.0;
	     UpBuffer[shift]=0; 
	     MUpBuffer[shift]=0;
	     MDnBuffer[shift]=0;
	     MMnBuffer[shift]=0; 
	    }
	    else if (RSI2 == RSI1) 
	    {
	     MMnBuffer[shift]=1.0;
	     UpBuffer[shift]=0; 
	     MUpBuffer[shift]=0;
	     MDnBuffer[shift]=0;
	     DnBuffer[shift]=0; 
	    }
	 
	}
	return(0);	
 }

